//chaos defense
//made by Chao / Trevor Wheeler
//for My Little Game Jam 2012

$movespeed = 60;
$movespeedplayer = 30;
$bits = 0;
$enemy = 0;
$health = 60;
$shoppage = 1;
$mainDiv = 1;
$wave = 0;
$timetilgui = 2000;

//AUDIO
new AudioDescription(AudioNonLooping)
{
volume = 1.0;
isLooping= false;
is3D = false;
type = $MusicAudioType;
};


new AudioDescription(AudioLooping)
{
volume = 1.0;
isLooping= true;
is3D = false;
type = $MusicAudioType;
};

// Background Music
new AudioProfile(backgroundAudio)
{
filename = "game/data/audio/bgsong.ogg";
description = "AudioLooping";
preload = true;
};

// Sound Effects
new AudioProfile(coinAudio)
{
filename = "game/data/audio/coin.wav";
description = "AudioNonLooping";
preload = true;
};

new AudioProfile(selectAudio)
{
filename = "game/data/audio/select.wav";
description = "AudioNonLooping";
preload = true;
};

new AudioProfile(ccAudio)
{
filename = "game/data/audio/cupcakedie.wav";
description = "AudioNonLooping";
preload = true;
};

new AudioProfile(timeAudio)
{
filename = "game/data/audio/time.wav";
description = "AudioNonLooping";
preload = true;
};

//start background song
alxPlay(backgroundAudio);

//executing gui codes
exec("game/gui/waveGui.gui");
exec("game/gui/shopGui.gui");

if (!isObject(titleBehavior))
{
   %template = new BehaviorTemplate(titleBehavior);
   
   %template.friendlyName = "Title Controls";
   %template.behaviorType = "Title Screen";
   %template.description  = "Enter to continue.";
   
   %template.addBehaviorField(enterKey, "Key to bind to confirm", keybind, "keyboard enter");
}

if (!isObject(playerBehavior))
{
   %template = new BehaviorTemplate(playerBehavior);
   
   %template.friendlyName = "Shield Movement";
   %template.behaviorType = "Input";
   %template.description  = "This is the shield.  It blocks stuff.";
   
   %template.addBehaviorField(upKey, "Key to bind to move shield up", keybind, "keyboard up");
   %template.addBehaviorField(downKey, "Key to bind to move shield down", keybind, "keyboard down");
}

if (!isObject(killerBehavior))
{
   %template = new BehaviorTemplate(killerBehavior);
   
   %template.friendlyName = "Killer";
   %template.behaviorType = "Misc";
   %template.description  = "Kills enemies on touch.";
}

if (!isObject(player2Behavior))
{
   %template = new BehaviorTemplate(player2Behavior);
   
   %template.friendlyName = "Shield 2 Movement";
   %template.behaviorType = "Input";
   %template.description  = "This is the shield 2.  It blocks stuff.";
   
   %template.addBehaviorField(wKey, "Key to bind to move shield 2 up", keybind, "keyboard w");
   %template.addBehaviorField(sKey, "Key to bind to move shield 2 down", keybind, "keyboard s");
}

if (!isObject(playerMainBehavior))
{
   %template = new BehaviorTemplate(playerMainBehavior);
   
   %template.friendlyName = "Player Movement";
   %template.behaviorType = "Input";
   %template.description  = "Main player that walks on the ground.";
   
   %template.addBehaviorField(rightKey, "Key to bind to move player right", keybind, "keyboard right");
   %template.addBehaviorField(leftKey, "Key to bind to move player left", keybind, "keyboard left");
}

if (!isObject(HouseBehavior))
{
   %template = new BehaviorTemplate(HouseBehavior);
   
   %template.friendlyName = "House";
   %template.behaviorType = "Misc";
   %template.description  = "The house.  Controls health and stuff for when enemies get by.";
}

function HouseBehavior::onCollision(%srcObj, %dstObj, %srcRef, %dstRef, %time, %normal, %count, %contacts)
{
   if(%dstObj.class $= "enemy")
   {
      %dstObj.safeDelete();
      $health -= 1;
      health.setSize(($health / 4), 3);
      healthtext.text = $health;
   }
}

function titleBehavior::onBehaviorAdd(%this)
{
   if (!isObject(moveMap))
      return;
   %this.owner.enableUpdateCallback(); 

   moveMap.bindObj(keyboard, "enter", "titleEnter", %this);
}

function titleBehavior::onBehaviorRemove(%this)
{
   if (!isObject(moveMap))
      return;

   %this.owner.disableUpdateCallback();
   
   moveMap.unbindObj(keyboard, "enter", %this);
}

function titleBehavior::titleEnter(%this)
{
   if($hasTitleEntered)
   {
      return;
   }
   $hasTitleEntered = true;
   logo1.setLinearVelocityX(150);
   logo1.setLinearVelocityY(150);
   logo2.setLinearVelocityX(-150);
   logo2.setLinearVelocityY(-150);
   logo3.setLinearVelocityX(150);
   logo3.setLinearVelocityY(-150);
   logo4.setLinearVelocityX(-150);
   logo4.setLinearVelocityY(150);
   story.setLinearVelocityY(-5);
   schedule(25000, 0, mainStageLevelSwitch);
}

function mainStageLevelSwitch()
{
   %level = "main.t2d";
   $changeLevel = sceneWindow2D.schedule( 1, loadLevel, "game/data/levels/" @ %level );
}


function playerMainBehavior::onBehaviorAdd(%this)
{
   if (!isObject(moveMap))
      return;
   %this.owner.enableUpdateCallback(); 
 
   //Basic controls
   moveMap.bindObj(keyboard, "right", "moveRight", %this);
   moveMap.bindObj(keyboard, "left", "moveLeft", %this);
   
   //Skill keybinds
   moveMap.bindObj(keyboard, "z", "setBonusShield", %this);
   moveMap.bindObj(keyboard, "x", "timeSpell", %this);
   moveMap.bindObj(keyboard, "c", "giganticShield", %this);
}

function playerMainBehavior::setBonusShield(%this)
{
   if(!$player::hasItem::chapter5)
   {
      return;
   }
   if($canUseSpella)
   {
      $canUseSpella = false;
      return;
   }
   if($canUseSpell)
   {
      nottext.visible = true;
      nottext.schedule(1000, setVisible, false);
      return;
   }
   barrier.setPositionX(player.getPositionX() + getRandom(-3,3));
   barrier.setPositionY(getRandom(-25.770, 9.474));
   $canUseSpell = true;
   schedule(2500, 0, canUseSpell);
   $canUseSpella = true;
}

function playerMainBehavior::giganticShield(%this)
{
   if(!$player::hasItem::chapter7)
   {
      return;
   }
   if($canUseSpellz)
   {
      $canUseSpellz = false;
      return;
   }
   if($canUseSpelly)
   {
      nottext.visible = true;
      nottext.schedule(1000, setVisible, false);
      return;
   }
   giganticshield.setLinearVelocityX(30);
   giganticshield.schedule(10000, setLinearVelocityX, 0);
   giganticshield.schedule(10000, setPositionX, -97.734);
   $canUseSpelly = true;
   schedule(20000, 0, canUseSpelly);
   $canUseSpellz = true;
}

function canUseSpell()
{
   $canUseSpell = false;
}
function canUseSpelly()
{
   $canUseSpelly = false;
}
function canUseSpellc()
{
   $canUseSpellc = false;
}
function mainDivOne()
{
   $mainDiv = 1;
   mainbg.visible = true;
}

function playerMainBehavior::timeSpell(%this)
{
   if(!$player::hasItem::chapter6)
   {
      return;
   }
   if($canUseSpellc)
   {
      nottext.visible = true;
      nottext.schedule(1000, setVisible, false);
      return;
   }
   if($canUseSpellb)
   {
      $canUseSpellb = false;
      return;
   }
   $mainDiv = 4;
   alxPlay(timeAudio);
   mainbg.visible = false;
   $canUseSpellc = true;
   $canUseSpellb = true;
   schedule(5000, 0, mainDivOne);
   schedule(20000, 0, canUseSpellc);
}


function playerMainBehavior::onUpdate(%this)
{
   //none so far
}

function playerMainBehavior::onBehaviorRemove(%this)
{
   if (!isObject(moveMap))
      return;

   %this.owner.disableUpdateCallback();
   
   moveMap.unbindObj(keyboard, "right", %this);
   moveMap.unbindObj(keyboard, "left", %this);
   
   %this.owner.right = 0;
   %this.owner.left = 0;
}

function playerMainBehavior::moveRight(%this, %val)
{
   if(%val == 1)
   {
      %this.owner.setAnimation(pony_active_run_strip4Animation);
   }
   if(%val == 0)
   {
      %this.owner.setAnimation(pony_activeAnimation);
   }
   
   %this.owner.right = %val;
   %this.owner.setLinearVelocityX((%val * 1) * $movespeedPlayer);
}
function playerMainBehavior::moveLeft(%this, %val)
{
   if(%val == 1)
   {
      %this.owner.setAnimation(pony_active_run_strip4Animation1);
   }
   if(%val == 0)
   {
      %this.owner.setAnimation(pony_activeAnimation);
   }
   %this.owner.left = %val;
   %this.owner.setLinearVelocityX((%val * -1) * $movespeedPlayer);
}

function playerBehavior::onBehaviorAdd(%this)
{
   if (!isObject(moveMap))
      return;
   %this.owner.enableUpdateCallback(); 
 
   //Basic controls
   moveMap.bindObj(keyboard, "up", "moveUp", %this);
   moveMap.bindObj(keyboard, "down", "moveDown", %this);
}

function player2Behavior::onBehaviorAdd(%this)
{
   if (!isObject(moveMap))
      return;
   %this.owner.enableUpdateCallback(); 
 
   //Basic controls
   moveMap.bindObj(keyboard, "w", "move2Up", %this);
   moveMap.bindObj(keyboard, "s", "move2Down", %this);
}

function player2Behavior::onUpdate(%this)
{
   if($player::hasItem::chapter4)
   {
      %this.owner.schedule(150, setPositionX, (player.getPositionX() - 25));
      if(%this.owner.getPositionY() >= 27.290)
      {
         %this.owner.setAngularVelocity(0);
         %this.owner.setLinearVelocityY(0);
         return;
      }
      if(%this.owner.getPositionY() <= -26.387)
      {
         %this.owner.setAngularVelocity(0);
         %this.owner.setLinearVelocityY(0);
         return;
      }
   }
}

function playerBehavior::onUpdate(%this)
{
   if($health <= 0)
   {
      alxStopAll();
      %level = "lose.t2d";
      $changeLevel = sceneWindow2D.schedule( 1, loadLevel, "game/data/levels/" @ %level );
   }
   %this.owner.schedule(150, setPositionX, (player.getPositionX() + 25));
   if(%this.owner.getPositionY() >= 27.290)
   {
      %this.owner.setAngularVelocity(0);
      %this.owner.setLinearVelocityY(0);
   }
   if(%this.owner.getPositionY() <= -26.387)
   {
      %this.owner.setAngularVelocity(0);
      %this.owner.setLinearVelocityY(0);
   }
   //WAVES
   if($wave == 0)
   {
      //no wave, resting time
      $enemy = 0;
      $donewavetext = false;
      $doneGUI = false;
      $wave++;
      return;
   }
   if($wave == 1)
   {
      //WAVE STATS
      %wave = 1; //what wave this is
      %enemies = 10; //how many enemies
      %cooldown = 60; //time between enemies
      %speedVariantMin = 60; //least amount of speed per enemy
      %speedVariantMax = 100; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 2)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 3)
   {
      //WAVE STATS
      %wave = 2; //what wave this is
      %enemies = 30; //how many enemies
      %cooldown = 40; //time between enemies
      %speedVariantMin = 60; //least amount of speed per enemy
      %speedVariantMax = 100; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 4)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 5)
   {
      //WAVE STATS
      %wave = 3; //what wave this is
      %enemies = 30; //how many enemies
      %cooldown = 20; //time between enemies
      %speedVariantMin = 60; //least amount of speed per enemy
      %speedVariantMax = 100; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 6)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 7)
   {
      //WAVE STATS
      %wave = 4; //what wave this is
      %enemies = 50; //how many enemies
      %cooldown = 20; //time between enemies
      %speedVariantMin = 60; //least amount of speed per enemy
      %speedVariantMax = 100; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 8)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 9)
   {
      //WAVE STATS
      %wave = 5; //what wave this is
      %enemies = 10; //how many enemies
      %cooldown = 30; //time between enemies
      %speedVariantMin = 120; //least amount of speed per enemy
      %speedVariantMax = 200; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 10)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 11)
   {
      //WAVE STATS
      %wave = 6; //what wave this is
      %enemies = 40; //how many enemies
      %cooldown = 20; //time between enemies
      %speedVariantMin = 80; //least amount of speed per enemy
      %speedVariantMax = 100; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 12)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 13)
   {
      //WAVE STATS
      %wave = 7; //what wave this is
      %enemies = 60; //how many enemies
      %cooldown = 20; //time between enemies
      %speedVariantMin = 80; //least amount of speed per enemy
      %speedVariantMax = 100; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 14)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 15)
   {
      //WAVE STATS
      %wave = 8; //what wave this is
      %enemies = 100; //how many enemies
      %cooldown = 20; //time between enemies
      %speedVariantMin = 80; //least amount of speed per enemy
      %speedVariantMax = 100; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 16)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 17)
   {
      //WAVE STATS
      %wave = 9; //what wave this is
      %enemies = 100; //how many enemies
      %cooldown = 15; //time between enemies
      %speedVariantMin = 80; //least amount of speed per enemy
      %speedVariantMax = 100; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 18)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 19)
   {
      //WAVE STATS
      %wave = 10; //what wave this is
      %enemies = 100; //how many enemies
      %cooldown = 10; //time between enemies
      %speedVariantMin = 40; //least amount of speed per enemy
      %speedVariantMax = 50; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 20)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 21)
   {
      //WAVE STATS
      %wave = 11; //what wave this is
      %enemies = 20; //how many enemies
      %cooldown = 30; //time between enemies
      %speedVariantMin = 200; //least amount of speed per enemy
      %speedVariantMax = 250; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 22)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 23)
   {
      //WAVE STATS
      %wave = 12; //what wave this is
      %enemies = 125; //how many enemies
      %cooldown = 15; //time between enemies
      %speedVariantMin = 100; //least amount of speed per enemy
      %speedVariantMax = 150; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 24)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 25)
   {
      //WAVE STATS
      %wave = 13; //what wave this is
      %enemies = 100; //how many enemies
      %cooldown = 2; //time between enemies
      %speedVariantMin = 50; //least amount of speed per enemy
      %speedVariantMax = 50; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 26)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 27)
   {
      //WAVE STATS
      %wave = 14; //what wave this is
      %enemies = 100; //how many enemies
      %cooldown = 10; //time between enemies
      %speedVariantMin = 80; //least amount of speed per enemy
      %speedVariantMax = 100; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "WAVE " @ %wave;
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 28)
   {
      //no wave, resting time      
      guienemytext.setText("<color:333333><font:Comic Sans MS:50>" @ $enemykilled @ "/" @ $enemy);
      guibitstext.setText("<color:333333><font:Comic Sans MS:50>+" @ $bitsthisround );
      if(!$doneGUI)
      {
         canvas.schedule($timetilgui, pushDialog, waveGUI);
         $doneGUI = true;
      }
      return;
   }
   if($wave == 29)
   {
      //WAVE STATS
      %wave = 15; //what wave this is
      %enemies = 200; //how many enemies
      %cooldown = 4; //time between enemies
      %speedVariantMin = 120; //least amount of speed per enemy
      %speedVariantMax = 140; //highest amount of speed per enemy
      
      //wave base code, no need to edit again
      if(!$donewavetext)
      {
         wavetext.text = "-!FINAL WAVE!-";
         wavetext.setLinearVelocityX(-100);
         wavetext.schedule(2000, setLinearVelocityX, 0);
         wavetext.schedule(2000, setPositionX, 100.802);
         $donewavetext = true;
         return;
      }
      if($enemy >= %enemies)
      {
         $wave++;
         return;
      }
      
      $spawnCD++;
      if($spawnCD >= %cooldown)
      {
         //spawn enemy
         $spawnCD = 0;
         $enemy++;
         %enemy = cupcake.clone(true);
         %enemy.setPositionX(61.377);
         %enemy.setPositionY(getRandom(-29.025, 27.702));
         %enemy.immovable = 0;
         %enemy.setLinearVelocityX(getRandom((-1 * %speedVariantMax) / $mainDiv, (-1 * %speedVariantMin) / $mainDiv));
         %enemy.setLinearVelocityY(getRandom(-5, 5));
      }
   }
   if($wave == 30)
   {
      %level = "win.t2d";
      $changeLevel = sceneWindow2D.schedule( 1, loadLevel, "game/data/levels/" @ %level );
   }
}

function nextWave()
{
   canvas.popDialog(waveGUI);
   $wave++;
   $enemykilled = 0;
   $enemy = 0;
   $bitsthisround = 0;
   $doneGUI = false;
   $donewavetext = false;
}

function nextShopPage()
{
   $shoppage++;
   if($shoppage > 8)
   {
      $shoppage = 1;
   }
   updateShopPage();   
}

function PrevShopPage()
{
   $shoppage--;
   if($shoppage < 1)
   {
      $shoppage = 8;
   }
   updateShopPage();   
}

function updateShopPage()
{
   if($shoppage == 1)
   {
      guiShopitemName.setText("<color:333333><font:Comic Sans MS:30>Chapter 1: Shield Mastery");
      guiShopitemDesc.setText("<color:333333><font:Comic Sans MS:20>This chapter teaches you all about magic shields.  You will be able to create a larger shield!");
      guiShopitemPrice.setText("<color:333333><font:Comic Sans MS:30>100 Bits");
      return;
   }
   if($shoppage == 2)
   {
      guiShopitemName.setText("<color:333333><font:Comic Sans MS:30>Chapter 2: Shield Control");
      guiShopitemDesc.setText("<color:333333><font:Comic Sans MS:20>This chapter teaches you about controlling your magic shield.  You will be able to move it faster!");
      guiShopitemPrice.setText("<color:333333><font:Comic Sans MS:30>100 Bits");
      return;
   }
   if($shoppage == 3)
   {
      guiShopitemName.setText("<color:333333><font:Comic Sans MS:30>Chapter 3: Adv Shield Control");
      guiShopitemDesc.setText("<color:333333><font:Comic Sans MS:20>The sequel to Chapter 2: Shield Control.  You will be able to move your shield even faster!  Requires Chapter 2.");
      guiShopitemPrice.setText("<color:333333><font:Comic Sans MS:30>350 Bits");
      return;
   }
   if($shoppage == 4)
   {
      guiShopitemName.setText("<color:333333><font:Comic Sans MS:30>Chapter 4: Multiple Shields");
      guiShopitemDesc.setText("<color:333333><font:Comic Sans MS:20>This chapter teaches you how to multitask.  You will be able to create two shields! (W and S to control)");
      guiShopitemPrice.setText("<color:333333><font:Comic Sans MS:30>450 Bits");
      return;
   }
   if($shoppage == 5)
   {
      guiShopitemName.setText("<color:333333><font:Comic Sans MS:30>Chapter 5: Extra Protection");
      guiShopitemDesc.setText("<color:333333><font:Comic Sans MS:20>This chapter teaches you how to set up bonus shields.  You will be able to set up stationary bonus shields! (Z to use)");
      guiShopitemPrice.setText("<color:333333><font:Comic Sans MS:30>400 Bits");
      return;
   }
   if($shoppage == 6)
   {
      guiShopitemName.setText("<color:333333><font:Comic Sans MS:30>Chapter 6: Time Spells");
      guiShopitemDesc.setText("<color:333333><font:Comic Sans MS:20>This chapter teaches you how to control time.  You will be able to slow down your enemies! (X to use)");
      guiShopitemPrice.setText("<color:333333><font:Comic Sans MS:30>400 Bits");
      return;
   }
   if($shoppage == 7)
   {
      guiShopitemName.setText("<color:333333><font:Comic Sans MS:30>Chapter 7: Gigantic Shields");
      guiShopitemDesc.setText("<color:333333><font:Comic Sans MS:20>This chapter teaches you how to make huge temporary shields.  You will be able to make gigantic shields that kill all enemies. (C to use)");
      guiShopitemPrice.setText("<color:333333><font:Comic Sans MS:30>250 Bits");
      return;
   }
   if($shoppage == 8)
   {
      guiShopitemName.setText("<color:333333><font:Comic Sans MS:30>House Repair Kit");
      guiShopitemDesc.setText("<color:333333><font:Comic Sans MS:20>All you need to repair parts of your house in one nifty kit! (gives back 10 life)");
      guiShopitemPrice.setText("<color:333333><font:Comic Sans MS:30>200 Bits");
      return;
   }
}

function buyItem()
{
   alxPlay(selectAudio);
   if($shoppage == 1)
   {
      if($player::hasItem::chapter1)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Already have this.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      if($bits < 100)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Not enough bits.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      $bits -= 100;
      $player::hasItem::chapter1 = true;
      //what the item does
      shield_1.setSize(25, 30);
   }
   if($shoppage == 2)
   {
      if($player::hasItem::chapter2)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Already have this.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      if($bits < 100)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Not enough bits.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      $bits -= 100;
      $player::hasItem::chapter2 = true;
      //what the item does
      $movespeed = 100;
   }
   if($shoppage == 3)
   {
      if(!$player::hasItem::chapter2)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Need chapter 2.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      if($player::hasItem::chapter3)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Already have this.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      if($bits < 350)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Not enough bits.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      $bits -= 350;
      $player::hasItem::chapter3 = true;
      //what the item does
      $movespeed = 150;
   }
   if($shoppage == 4)
   {
      if($player::hasItem::chapter4)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Already have this.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      if($bits < 450)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Not enough bits.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      $bits -= 450;
      $player::hasItem::chapter4 = true;
      //what the item does
      shield_2.immovable = false;
      shield_2.setPositionY(5.805);
   }
   if($shoppage == 5)
   {
      if($player::hasItem::chapter5)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Already have this.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      if($bits < 400)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Not enough bits.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      $bits -= 400;
      $player::hasItem::chapter5 = true;
      //what the item does
      //nothing, it's a skill
   }
   if($shoppage == 6)
   {
      if($player::hasItem::chapter6)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Already have this.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      if($bits < 400)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Not enough bits.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      $bits -= 400;
      $player::hasItem::chapter6 = true;
      //what the item does
      //nothing, it's a skill
   }
   if($shoppage == 7)
   {
      if($player::hasItem::chapter7)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Already have this.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      if($bits < 250)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Not enough bits.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      $bits -= 250;
      $player::hasItem::chapter7 = true;
      //what the item does
      //nothing, it's a skill
   }
   if($shoppage == 8)
   {
      if($bits < 200)
      {
         guiShopproblem.setVisible(true);
         guiShopproblem.setText("Not enough bits.");
         guiShopproblem.schedule(500, setVisible, false);
         return;
      }
      $bits -= 200;
      //what the item does
      $health += 10;
      health.setSize(($health / 4), 3);
      healthtext.text = $health;
   }
   updateBits();
}

function playerBehavior::onBehaviorRemove(%this)
{
   if (!isObject(moveMap))
      return;

   %this.owner.disableUpdateCallback();
   
   moveMap.unbindObj(keyboard, "up", %this);
   moveMap.unbindObj(keyboard, "down", %this);
   
   %this.owner.up = 0;
   %this.owner.down = 0;
}

function player2Behavior::onBehaviorRemove(%this)
{
   if (!isObject(moveMap))
      return;

   %this.owner.disableUpdateCallback();
   
   moveMap.unbindObj(keyboard, "w", %this);
   moveMap.unbindObj(keyboard, "s", %this);
   
   %this.owner.up = 0;
   %this.owner.down = 0;
}

function playerBehavior::moveUp(%this, %val)
{
   if(%this.owner.getPositionY() <= -26.387)
   {
      %this.owner.setAngularVelocity(0);
      %this.owner.setLinearVelocityY(0);
      return;
   }
   %this.owner.up = %val;
   %this.owner.setAngularVelocity(%val * -75);
   %this.owner.setLinearVelocityY((%val * -1) * $movespeed);
}

function playerBehavior::moveDown(%this, %val)
{
   if(%this.owner.getPositionY() >= 27.290)
   {
      %this.owner.setAngularVelocity(0);
      %this.owner.setLinearVelocityY(0);
      return;
   }
   %this.owner.up = %val;
   %this.owner.setAngularVelocity(%val * 75);
   %this.owner.setLinearVelocityY((%val * 1) * $movespeed);
}

function player2Behavior::move2Up(%this, %val)
{
   if(%this.owner.getPositionY() <= -26.387)
   {
      %this.owner.setAngularVelocity(0);
      %this.owner.setLinearVelocityY(0);
      return;
   }
   %this.owner.up = %val;
   %this.owner.setAngularVelocity(%val * -75);
   %this.owner.setLinearVelocityY((%val * -1) * $movespeed);
}

function player2Behavior::move2Down(%this, %val)
{
   if(%this.owner.getPositionY() >= 27.290)
   {
      %this.owner.setAngularVelocity(0);
      %this.owner.setLinearVelocityY(0);
      return;
   }
   %this.owner.up = %val;
   %this.owner.setAngularVelocity(%val * 75);
   %this.owner.setLinearVelocityY((%val * 1) * $movespeed);
}

function playerBehavior::onCollision(%srcObj, %dstObj, %srcRef, %dstRef, %time, %normal, %count, %contacts)
{
   if(%dstObj.class $= "enemy")
   {
      if(!%dstObj.hasbeenkilled)
      {
         $enemykilled += 1;
         %dstObj.hasbeenkilled = true;
      }
      %dstObj.setSize(12, 12);
      %dstObj.schedule(50, setSize, 16, 16);
      %dstObj.schedule(50, setSize, 14, 14);
      %dstObj.schedule(75, setSize, 10, 10);
      %dstObj.schedule(74, setBlendStatus, true);
      %dstObj.schedule(75, setBlendColor, 50, 50, 50, 255);
      %dstObj.schedule(100, setSize, 7, 7);
      %dstObj.schedule(125, setSize, 4, 4);
      %dstObj.schedule(150, safeDelete);
      
      alxPlay(ccAudio);
      
      //DROP BITS      
      %random = getRandom(0, 100);
      if($wave >= 29)
      {
         %random = 0;
      }
      if(%random >=65)
      {
         %bit = bitDrop.clone(true);
         %bit.setPositionX(%dstObj.getPositionX() + getRandom(-2, 2));
         %bit.setPositionY(%dstObj.getPositionY() + getRandom(-2, 2));
         %bit.immovable = 0;
         %bit.coined = true;
         %bit.setLinearVelocityY(getRandom(60, 80));
         
         %dirTell = player.getPositionX() - %bit.getPositionX();
         if(%dirTell > 0)
         {
            %bit.setLinearVelocityX(getRandom(10,100));
         }
         if(%dirTell < 0)
         {
            %bit.setLinearVelocityX(getRandom(-20,-10));
         }
      }
   }
}

function killerBehavior::onCollision(%srcObj, %dstObj, %srcRef, %dstRef, %time, %normal, %count, %contacts)
{
   if(%dstObj.class $= "enemy")
   {
      if(!%dstObj.hasbeenkilled)
      {
         $enemykilled += 1;
         %dstObj.hasbeenkilled = true;
      }
      %dstObj.setSize(12, 12);
      %dstObj.schedule(50, setSize, 16, 16);
      %dstObj.schedule(50, setSize, 14, 14);
      %dstObj.schedule(75, setSize, 10, 10);
      %dstObj.schedule(74, setBlendStatus, true);
      %dstObj.schedule(75, setBlendColor, 50, 50, 50, 255);
      %dstObj.schedule(100, setSize, 7, 7);
      %dstObj.schedule(125, setSize, 4, 4);
      %dstObj.schedule(150, safeDelete);
      
      alxPlay(ccAudio);      
      
      //DROP BITS      
      %random = getRandom(0, 100);
      if($wave >= 29)
      {
         %random = 0;
      }
      if(%random >=65)
      {
         %bit = bitDrop.clone(true);
         %bit.setPositionX(%dstObj.getPositionX() + getRandom(-2, 2));
         %bit.setPositionY(%dstObj.getPositionY() + getRandom(-2, 2));
         %bit.immovable = 0;
         %bit.coined = true;
         %bit.setLinearVelocityY(getRandom(60, 80));
         
         %dirTell = player.getPositionX() - %bit.getPositionX();
         if(%dirTell > 0)
         {
            %bit.setLinearVelocityX(getRandom(10,20));
         }
         if(%dirTell < 0)
         {
            %bit.setLinearVelocityX(getRandom(-20,-10));
         }
      }
   }
}

function player2Behavior::onCollision(%srcObj, %dstObj, %srcRef, %dstRef, %time, %normal, %count, %contacts)
{
   if(%dstObj.class $= "enemy")
   {
      if(!%dstObj.hasbeenkilled)
      {
         $enemykilled += 1;
         %dstObj.hasbeenkilled = true;
      }
      %dstObj.setSize(12, 12);
      %dstObj.schedule(50, setSize, 16, 16);
      %dstObj.schedule(50, setSize, 14, 14);
      %dstObj.schedule(75, setSize, 10, 10);
      %dstObj.schedule(74, setBlendStatus, true);
      %dstObj.schedule(75, setBlendColor, 50, 50, 50, 255);
      %dstObj.schedule(100, setSize, 7, 7);
      %dstObj.schedule(125, setSize, 4, 4);
      %dstObj.schedule(150, safeDelete);
      
      alxPlay(ccAudio);
      
      //DROP BITS      
      %random = getRandom(0, 100);
      if($wave >= 29)
      {
         %random = 0;
      }
      if(%random >=65)
      {
         %bit = bitDrop.clone(true);
         %bit.setPositionX(%dstObj.getPositionX() + getRandom(-2, 2));
         %bit.setPositionY(%dstObj.getPositionY() + getRandom(-2, 2));
         %bit.immovable = 0;
         %bit.coined = true;
         %bit.setLinearVelocityY(getRandom(60, 80));
         
         %dirTell = player.getPositionX() - %bit.getPositionX();
         if(%dirTell > 0)
         {
            %bit.setLinearVelocityX(getRandom(10,20));
         }
         if(%dirTell < 0)
         {
            %bit.setLinearVelocityX(getRandom(-20,-10));
         }
         
      }
   }
}

function playerMainBehavior::onCollision(%srcObj, %dstObj, %srcRef, %dstRef, %time, %normal, %count, %contacts)
{
   if(%dstObj.class $= "bit")
   {
      %dstObj.safeDelete();
      $bits += 1;
      $bitsthisround += 1;
      bittext.text = $bits;
      alxPlay(coinAudio);
   }
}

function bit::onCollision(%srcObj, %dstObj, %srcRef, %dstRef, %time, %normal, %count, %contacts)
{
   if(%dstObj.class $= "bitcoll")
   {
      //%srcObj.setPositionX((player.getPositionX() + %srcObj.getPositionX()) / 2);
      %dirTell = player.getPositionX() - %srcObj.getPositionX();
      if(%dirTell > 0)
      {
         %srcObj.setLinearVelocityX(getRandom(10,100));
      }
      if(%dirTell < 0)
      {
         %srcObj.setLinearVelocityX(getRandom(-100,-10));
      }
   }
}

function updateBits()
{
   bittext.text = $bits;
   guibitstotaltext.setText("<color:333333><font:Comic Sans MS:50>" @ $bits );
}